SystemOrganization addCategory: #'Ice-Core'!
SystemOrganization addCategory: #'Ice-Core-Announcement'!

Trait named: #TICAnnouncer
	uses: {}
	category: 'Ice-Core'!

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:39'!
announce: anAnnouncement 
	self announcer announce: anAnnouncement ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:39'!
announcer 
	^ICRepositoryManager uniqueInstance announcer ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
on: anAnnouncement do: aBlock
	self announcer on: anAnnouncement do: aBlock! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
suspendAllAnnouncementsWhile: aBlock
	self announcer suspendAllWhile: aBlock  ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
unsubscribe: anObject
	self announcer unsubscribe: anObject  ! !

Trait named: #TICGeneratorAware
	uses: {}
	category: 'Ice-Core'!

!TICGeneratorAware methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 20:17'!
generator 
	^ICSourceGenerator default! !

Announcer subclass: #ICAnnouncer
	instanceVariableNames: 'suspendAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAnnouncer methodsFor: 'announce' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
announce: anAnnouncement
	suspendAll ifTrue: [ ^anAnnouncement ].
	^super announce: anAnnouncement! !

!ICAnnouncer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
initialize 
	super initialize.
	suspendAll := false.! !

!ICAnnouncer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
suspendAllWhile: aBlock
	suspendAll := true.
	aBlock ensure: [ suspendAll := false ]! !

!RemovedEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:04'!
iceAccept: aManager
	  aManager eventRemove: self! !

!AddedEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:04'!
iceAccept: aManager
	  aManager eventAdd: self.! !

!AbstractEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:05'!
iceAccept: aManager
	  aManager eventUpdate: self.! !

Announcement subclass: #ICAnnouncement
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

!ICAnnouncement class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository: aRepository 
	^self new 
		repository: aRepository;
		yourself    ! !

!ICAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository
	^ repository! !

!ICAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository: anObject
	repository := anObject! !

ICAnnouncement subclass: #ICContainerAddedAnnouncement
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

!ICContainerAddedAnnouncement class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
repository: aRepository container: aContainer
	^(self repository: aRepository)
		container: aContainer;
		yourself! !

!ICContainerAddedAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
container
	^ container! !

!ICContainerAddedAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
container: anObject
	container := anObject! !

ICAnnouncement subclass: #ICRepositoryAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

ICAnnouncement subclass: #ICRepositoryRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

Object subclass: #ICAction
	instanceVariableNames: 'timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAction classSide methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:49'!
for: anObject
	^self basicNew 
		initialize: anObject;
		yourself! !

!ICAction classSide methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
new 
	self error: 'Use #for:'! !

!ICAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:27'!
classCategory
	^self subclassResponsibility! !

!ICAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 14:39'!
className 
	^self subclassResponsibility! !

!ICAction methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
initialize
	super initialize.
	timeStamp := TimeStamp now.    ! !

!ICAction methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
initialize: anObject
	self subclassResponsibility  ! !

!ICAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:16'!
isNew 
	^false! !

!ICAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isRemove 
	^false! !

!ICAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isUpdate 
	^self isRemove not! !

!ICAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:07'!
sameAs: anAction
	^self subclassResponsibility! !

!ICAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
timeStamp 
	^timeStamp ! !

ICAction subclass: #ICClassAction
	instanceVariableNames: 'name category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICClassAction subclass: #ICAddClassAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAddClassAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:16'!
isNew 
	^true! !

!ICClassAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:51'!
category 
	^category! !

!ICClassAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:27'!
classCategory 
	^self category! !

!ICClassAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:22'!
className 
	^self name! !

!ICClassAction methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:52'!
initialize: anObject
	name := anObject name.
	category := anObject category.
	self initialize.  ! !

!ICClassAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:51'!
name 
	^name! !

!ICClassAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 16:22'!
sameAs: anAction
	^(self species = anAction species)
		and: [ self name = anAction name ]  ! !

ICClassAction subclass: #ICRemoveClassAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICRemoveClassAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isRemove 
	^true! !

ICClassAction subclass: #ICUpdateClassAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICAction subclass: #ICMethodAction
	instanceVariableNames: 'name category className classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICMethodAction subclass: #ICAddMethodAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICMethodAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
category 
	^category! !

!ICMethodAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
classCategory 
	^classCategory ! !

!ICMethodAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
className 
	^className ! !

!ICMethodAction methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 16:35'!
initialize: aMethodReference
	name := aMethodReference methodSymbol.	
	category := aMethodReference category asLowercase asSymbol.
	className := aMethodReference classSymbol.
	classCategory := (Smalltalk at: className) category.
	self initialize.! !

!ICMethodAction methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
name 
	^name! !

!ICMethodAction methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
sameAs: anAction
	^((self species = anAction species)
		and: [ self className = anAction className ])
		and: [ self name = anAction name ]  ! !

ICMethodAction subclass: #ICRemoveMethodAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICMethodAction subclass: #ICUpdateMethodAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

Object subclass: #ICChange
	instanceVariableNames: 'className classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 10:22'!
className: nameString category: categoryString 
	^self basicNew 
		initializeClassName: nameString category: categoryString;
		yourself! !

!ICChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 10:22'!
new 
	self error: 'Use className:category:'! !

!ICChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 10:42'!
applyOn: aRepository
	^self subclassResponsibility! !

!ICChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:20'!
classCategory
	^ classCategory! !

!ICChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:20'!
className 
	^className! !

!ICChange methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 12:57'!
fileOn: aReference
	^aReference / self classCategory / (self className, ICRepository fileExtension)
	! !

!ICChange methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/17/2011 10:21'!
initializeClassName: nameString category: categoryString
	self initialize.
	className := nameString.
	classCategory := categoryString.! !

ICChange subclass: #ICRemoveClassChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICRemoveClassChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 10:51'!
applyOn: aRepository
	| file |
	file := self fileOn: aRepository storage.
	file exists ifTrue: [ file delete ].
	aRepository removeHistoryAt: self className  
! !

ICChange subclass: #ICUpdateClassChange
	uses: TICGeneratorAware
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICUpdateClassChange class
	uses: TICGeneratorAware classTrait
	instanceVariableNames: ''!

!ICUpdateClassChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 11:25'!
applyOn: aRepository
	| file |
	file := self fileOn: aRepository storage.
	file parent ensureDirectory.
	file fileStreamDo: [ :stream | stream nextPutAll: self source ].
	aRepository 
		historyAt: self className
		put: file entry modification asTimeStamp! !

!ICUpdateClassChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 13:02'!
source
 	^self generator sourceForClass: (Smalltalk at: self className)! !

ICUpdateClassChange subclass: #ICUpdateExtensionsChange
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICUpdateExtensionsChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 13:13'!
className: nameString category: categoryString packages: aCollection
	^self basicNew 
		initializeClassName: nameString 
			category: categoryString
			packages: aCollection;
		yourself! !

!ICUpdateExtensionsChange methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/17/2011 13:13'!
initializeClassName: nameString category:  categoryString packages: aCollection
	self initializeClassName: nameString category: categoryString.
	packages := aCollection.! !

!ICUpdateExtensionsChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 13:12'!
packages 
	^packages! !

Object subclass: #ICContainer
	instanceVariableNames: 'timeStamp actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:16'!
for: anObject 
	^self basicNew 
		initialize: anObject;
		yourself! !

!ICContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:16'!
new 
	self error: 'Use #for:'! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:18'!
actions
	^actions ifNil: [ actions := Dictionary new ]! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:18'!
addAction: anAction
	self removeAllRelatedActions: anAction.
	(self actions 
		at: anAction className 
		ifAbsentPut: [ OrderedCollection new ])
		add: anAction.
	self touched.! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:28'!
allActions 
	^self actions values 
		inject: OrderedCollection new 
		into: [ :all :each | all addAll: each; yourself ]! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 08:29'!
allClassNames
	^self actions keys asSet! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:03'!
canContain: anAction
	^self subclassResponsibility
  ! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 11:12'!
changes 
	| changes |
	changes := OrderedCollection new. 
	self actions keysAndValuesDo: [ :className :classActions |
		changes add: (classActions last isUpdate 
			ifTrue: [ ICUpdateClassChange className: self className category: self classCategory ]
			ifFalse: [ ICRemoveClassChange className: self className category: self classCategory ]) ].
	^changes! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:19'!
handleClass: aClass
	self subclassResponsibility! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:21'!
handleMethod: aMethodReference
	self subclassResponsibility! !

!ICContainer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/16/2011 18:36'!
incorporate  ! !

!ICContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 15:02'!
initialize 
	super initialize.
	self touched! !

!ICContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:17'!
initialize: anObject
	self subclassResponsibility    ! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:23'!
isAdding: aString
	^(self actions at: aString) anySatisfy: #isNew      ! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 14:46'!
isDirty 
	^self actions notEmpty! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:01'!
isExtension 
	^false! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:04'!
isPackage
	^false  ! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:22'!
isRemoving: aString
	^(self actions at: aString) anySatisfy: #isRemove! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:23'!
isUpdating: aString
	^(self actions at: aString) noneSatisfy: [ :each | each isNew or: [ each isRemove ] ].    ! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:03'!
name 
	^self subclassResponsibility! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 12:51'!
removeAction: anAction
	| classActions |
	
	classActions := (self actions at: anAction className) reject: [ :each | each = anAction ].
	classActions 
		ifNotEmpty: [ self actions at: anAction className put: classActions ] 
		ifEmpty: [ self actions removeKey: anAction className ]! !

!ICContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 15:23'!
removeAllRelatedActions: anAction
	| actionCollection |
	actionCollection := (self actions at: anAction className ifAbsent: [ nil ]).
	actionCollection ifNil: [ ^self ].
	
	self actions 
		at: anAction className 
		put: (actionCollection reject: [ :each | each sameAs: anAction ])
! !

!ICContainer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2011 11:06'!
reset 
	actions := nil! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:24'!
timeStamp
	^timeStamp! !

!ICContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 15:01'!
touched 
	timeStamp := TimeStamp now! !

ICContainer subclass: #ICExtensionContainer
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICExtensionContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:41'!
canContain: anAction
	^self categoryMatch: anAction category  ! !

!ICExtensionContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 12:42'!
categoryMatch: aSymbolOrString
	^(self packages 
		collect: [ :each | '*', each name asLowercase])
		anySatisfy: [ :each | each = aSymbolOrString or: [ aSymbolOrString beginsWith: each, '-' ] ]    	  ! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 16:51'!
changes 
	| changes packages |
	packages := self packages.
	changes := OrderedCollection new. 
	self actions keysAndValuesDo: [ :className :classActions |
		changes add: (ICUpdateExtensionsChange 
			className: className 
			category: self name
			packages: packages) ].
	^changes! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:21'!
handleClass: aClass 
	"Extension package does not handle classes (just methods)"
	^false  ! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:25'!
handleMethod: aMethodReference  
	^self categoryMatch: aMethodReference category! !

!ICExtensionContainer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/16/2011 19:44'!
incorporate: aPackage 
	| packageNames |
	"Remove pre-saved actions who no longer corresponds to this place.
	 Then adds all the method extensions from this package"

	(self allActions select: [ :each | aPackage canContain: each  ]) 
		do: [ :each | self removeAction: each ].
	
	packageNames := self packages collect: #name.
	(aPackage packageInfo extensionMethods
		reject: [ :each | packageNames includes: (Smalltalk at: each classSymbol) category ])
		do: [ :each | self addAction: (ICAddMethodAction for: each)  ]! !

!ICExtensionContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 14:19'!
initialize: aRepository
	repository := aRepository.
	self initialize.! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 14:18'!
isExtension 
	^true! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:05'!
name
	^'Extensions'! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:43'!
packages 
	^repository containers select: [ :each | each isExtension not ]! !

ICContainer subclass: #ICPackageContainer
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICPackageContainer methodsFor: 'testing' stamp: 'DiogenesMoreira 2/22/2011 19:46'!
= other
	 [ ^ self name = other name ] ifError:[ ^ false ]! !

!ICPackageContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:27'!
canContain: anAction
	^self categoryMatch: anAction classCategory  ! !

!ICPackageContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 12:27'!
categoryMatch: aSymbolOrString
	^(aSymbolOrString = self name) 
		or: [ aSymbolOrString beginsWith: self name, '-' ]  ! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 18:51'!
changes 
	| changes |
	changes := OrderedCollection new. 
	self actions keysAndValuesDo: [ :className :classActions |
		changes add: (classActions last isUpdate 
			ifTrue: [ 
				ICUpdateClassChange 
					className: className 
					category: classActions anyOne classCategory ]
			ifFalse: [ 
				ICRemoveClassChange 
					className: className 
					category: classActions anyOne classCategory ]) ].
	^changes! !

!ICPackageContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:27'!
handleClass: aClass  
	^self categoryMatch: aClass category  ! !

!ICPackageContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:24'!
handleMethod: aMethodReference
	^self handleClass: aMethodReference actualClass category
	  ! !

!ICPackageContainer methodsFor: 'testing' stamp: 'DiogenesMoreira 2/22/2011 19:44'!
hash
	 ^ self name hash.! !

!ICPackageContainer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/16/2011 17:32'!
incorporate 
	self packageInfo classes 
		do: [ :each | self addAction: (ICAddClassAction for: each) ]! !

!ICPackageContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:17'!
initialize: aPackageInfo
	name := aPackageInfo packageName. 
	self initialize! !

!ICPackageContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:04'!
isPackage
	^true! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:03'!
name 
	^name! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:33'!
packageInfo 
	^PackageOrganizer default 
		packageNamed: self name
		ifAbsent: [ self error: 'No package named ', self name, ' in system' ]! !

Object subclass: #ICRepository
	uses: TICGeneratorAware + TICAnnouncer
	instanceVariableNames: 'containers storage history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICRepository class
	uses: TICGeneratorAware classTrait + TICAnnouncer classTrait
	instanceVariableNames: ''!

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 12:57'!
fileExtension 
	^'.st'! !

!ICRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
new 
	self error: 'Use #on:'! !

!ICRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
on: aFilesystemReference
	^self basicNew 
		initialize: aFilesystemReference;
		yourself! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:19'!
statusChanged
	^#changed! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
statusConflict
	^#conflict! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
statusOk
	^#ok! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:19'!
statusStorageChanged 
	^#storageChanged! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:36'!
actions 
	^self containers 
		inject: Set new 
		into: [ :all :each | all addAll: each allActions; yourself ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:46'!
addAction: anAction
	(self containerWhoCanContain: anAction) addAction: anAction.
	self touchClassName: anAction className.! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:50'!
addContainer: aContainer
	self containers add: aContainer.
	self incorporateContainer: aContainer.
	self announce: (ICContainerAddedAnnouncement 
		repository: self 
		container: aContainer)    ! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 15:56'!
addPackage: aPackageInfo
	self addContainer: (ICPackageContainer for: aPackageInfo)  ! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 15:57'!
addPackageNamed: aString
	self addPackage: (PackageOrganizer default packages
		detect: [ :each | each packageName = aString ]).
! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 10:58'!
changes 
	^self containersWithActions 
		inject: #()
		into: [ :all :each | all, each changes ]  ! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 17:39'!
containerWhoCanContain: anAction
	^self containers detect: [ :each | each canContain: anAction ]  ! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 18:38'!
containers
	^containers! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 17:39'!
containersWithActions
	^self containers select: #isDirty! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:40'!
extensionContainer
	^self containers detect: #isExtension! !

!ICRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:18'!
handleClass: aClass
	^self packages anySatisfy: [ :each | each handleClass: aClass ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:25'!
history 
	^history ifNil: [ history := Dictionary new ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 20:14'!
historyAt: aSymbol
	^self history 
		at: aSymbol 
		ifAbsent: [ nil ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:44'!
historyAt: aSymbol put: aTimeStamp
	^self history 
		at: aSymbol 
		put: aTimeStamp! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 08:29'!
incorporateContainer: aContainer
	self 
		assert: aContainer isExtension not
		description: 'You can''t incorporate extensions container'.
	aContainer incorporate.
	self extensionContainer incorporate: aContainer.
	(aContainer allClassNames, self extensionContainer allClassNames)
		do: [ :each | self history at: each ifAbsentPut: [ TimeStamp now ] ].! !

!ICRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 18:38'!
initialize 
	super initialize.
	containers := Set with: (ICExtensionContainer for: self)! !

!ICRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
initialize: aFilesystemReference 
	storage := aFilesystemReference.
	self initialize  ! !

!ICRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 17:37'!
isDirty
	^self containers anySatisfy: #isDirty  ! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
lastInternalTimeStamp
	^ self history  
		ifNotEmpty: [ self history values max ] 
		ifEmpty: [ nil ]! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 23:16'!
lastStorageTimeStamp
	^ self storageEntries 
		ifNotEmpty: [ :entries| (entries collect: #modification) max asTimeStamp  ] 
		ifEmpty: [ nil ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:08'!
name 
	^self storage asString! !

!ICRepository methodsFor: 'printing' stamp: 'EstebanLorenzano 1/17/2011 22:08'!
printOn: aStream 
	aStream nextPutAll: self name! !

!ICRepository methodsFor: 'operations' stamp: 'EstebanLorenzano 1/19/2011 11:05'!
pull 
	self storageNewerEntries do: [ :each |
		each reference readStreamDo: [ :stream | 
			self generator installSource: stream contents asString ] ].
	self reset.! !

!ICRepository methodsFor: 'operations' stamp: 'EstebanLorenzano 1/19/2011 11:05'!
push 
	self changes do: [ :each | each applyOn: self ].
	self reset.! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:51'!
removeHistoryAt: aSymbol
	^self history removeKey: aSymbol ifAbsent: []
		! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 11:05'!
reset 
	self containers do: #reset! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:26'!
status
	| internalChanged storageChanged storageLastDate internalLastDate |

	internalChanged := false.
	storageChanged := false.
	internalLastDate := self lastInternalTimeStamp.
	storageLastDate := self lastStorageTimeStamp.	
	
	(internalLastDate isNil and: [ storageLastDate isNil ]) ifTrue: [ ^self class statusOk ]. 
	(internalLastDate notNil and: [ storageLastDate isNil ]) ifTrue: [ ^self class statusChanged ].	
	(internalLastDate isNil and: [ storageLastDate notNil ]) ifTrue: [ ^self class statusStorageChanged ].
	
	self isDirty ifTrue: [ internalChanged := true ].
	(internalLastDate > storageLastDate) ifTrue: [ internalChanged := true ].
	(internalLastDate < storageLastDate) ifTrue: [ storageChanged := true ]. 
	
	(internalChanged and: [ storageChanged not ]) ifTrue: [ ^self class statusChanged ].
	(internalChanged not and: [ storageChanged ]) ifTrue: [ ^self class statusStorageChanged ].
	(internalChanged and: [ storageChanged]) ifTrue: [ ^self class statusConflict ].
	
	^self class statusOk! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 17:08'!
storage 
	^storage! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 20:19'!
storageEntries 
	"Answer a collection of entries for all files in repository"
	^(self storage allEntries
		select: #isFile)
		select: [ :each | each basename endsWith: self class fileExtension ]! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 23:15'!
storageNewerEntries 
	^self storageEntries 
		select: [ :each | 
			| lastImageModification lastModification |
			lastImageModification := self historyAt: (each basename copyUpTo: $.) asSymbol. 
			lastModification := each modification.
			lastImageModification isNil or: [ lastImageModification < lastModification ] ]! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 10:46'!
touchClassName: aString
	self history 
		at: aString 
		put: TimeStamp now! !

Object subclass: #ICRepositoryManager
	uses: TICAnnouncer
	instanceVariableNames: 'repositories announcer'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'Ice-Core'!

ICRepositoryManager class
	uses: TICAnnouncer classTrait
	instanceVariableNames: ''!

!ICRepositoryManager class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 16:59'!
new 
	self error: 'Use #uniqueInstance'! !

!ICRepositoryManager class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 16:57'!
uniqueInstance 
	^UniqueInstance ifNil: [ UniqueInstance := self basicNew initialize ]! !

!ICRepositoryManager methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 12:17'!
addClass: aClass 
	(self repositories 
		select: [ :each | each handleClass: aClass ])
		do: [ :each | each addAction: (ICAddClassAction for: aClass) ]! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:09'!
addRepository: aRepository
	self repositories add: aRepository.
	self announce: (ICRepositoryAddedAnnouncement repository: aRepository).
	^aRepository! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/18/2011 09:12'!
addRepositoryOn: aFilesystemReference
	self addRepository: (ICRepository on: aFilesystemReference)  ! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:09'!
addRepositoryOnDirectory: aString
	^self addRepository: (ICRepository on: (self toFileSystem: aString))! !

!ICRepositoryManager methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:41'!
announcer 
	^announcer ifNil: [ announcer := ICAnnouncer new ]! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'EstebanLorenzano 1/19/2011 11:52'!
event: anEvent
	anEvent iceAccept: self  ! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'EstebanLorenzano 2/3/2011 10:29'!
eventAdd: anEvent
	self flag: #todo. "Not yet implemented"	
	"anEvent itemKind = #class ifTrue: [ self addClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ self addMethod: anEvent itemMethod methodReference ]."
	! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'EstebanLorenzano 2/3/2011 10:28'!
eventRemove: anEvent
	self flag: #todo. "Not yet implemented"	
	"anEvent itemKind = #class ifTrue: [ self removeClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ 
		| reference |
		self flag: #hack. ""MethodReference is not bringing it's category when removed, and I need it for 
		checking repositories""
		reference := anEvent itemMethod methodReference.
		reference category: (self environmentAt: #protocol).   
		self removeMethod: reference ]."
 ! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'EstebanLorenzano 2/3/2011 10:25'!
eventUpdate: anEvent
	self flag: #todo. "Not yet implemented"
	"anEvent itemKind = #class ifTrue: [ self updateClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ self updateMethod: anEvent itemMethod methodReference ]."
 ! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
initialize 
	super initialize.
	self registerForListenEvents.
	repositories := OrderedCollection new. ! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
registerForListenEvents
	SystemChangeNotifier uniqueInstance 
		notify: self
		ofAllSystemChangesUsing: #event:! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:09'!
removeAllRepositories
	repositories := OrderedCollection new! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:45'!
removeRepository: aRepository
	self repositories remove: aRepository.
	self announce: (ICRepositoryRemovedAnnouncement repository: aRepository)! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:00'!
repositories 
	^repositories! !

!ICRepositoryManager methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 16:59'!
resetAnnouncer 
	announcer := nil! !

!ICRepositoryManager methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 13:06'!
toFileSystem: aDirectoryOrString
	^aDirectoryOrString isString 
		ifTrue: [ 
			(aDirectoryOrString subStrings: '/')
				inject: FSDiskFilesystem root
				into: [ :dir :path | dir / path ]  ]
		ifFalse: [ aDirectoryOrString ]! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
unregisterForListenEvents
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

Object subclass: #ICSourceGenerator
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICSourceGenerator class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 19:31'!
default 
	^Default ifNil: [ Default := self new ]! !

!ICSourceGenerator class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 19:32'!
default: aGenerator
	Default := aGenerator! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 20:02'!
installSource: sourceString
	(RWBinaryOrTextStream with: sourceString) reset fileInObjectAndCode! !

!ICSourceGenerator methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
methodExtensionsForClass: aClass container: aPackageContainer
	^(aPackageContainer packageInfo extensionMethodsForClass: aClass) 
		collect: #methodSymbol! !

!ICSourceGenerator methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
methodExtensionsForClass: aClass containers: aCollection
	^aCollection 
		inject: #()
		into: [ :all :each | all,  (self methodExtensionsForClass: aClass container: each) ]! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 19:21'!
sourceForClass: aClass
	^String streamContents: [ :stream | 
		aClass 
			fileOutOn: stream 
			moveSource: false 
			toFile: nil ]! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
sourceForClass:  aClass containers: aCollection
	| methodNames |
	
	methodNames := self methodExtensionsForClass: aClass containers: aCollection.
	^String streamContents: [ :stream | 
		methodNames do: [ :each | 
			aClass 
				printMethodChunk: each 
				withPreamble: true 
				on: stream 
				moveSource:  false 
				toFile: nil ] ]! !
